Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/SelfTest/include/test.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/SelfTest/include/test.h	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/SelfTest/include/test.h	(revision 88)
@@ -16,4 +16,5 @@
 
 #include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/include/Read_queue.h"
+#include "Common/include/Time.h"
 
 using namespace std;
@@ -30,33 +31,2 @@
 	      morpheo::behavioural::core::multi_execute_loop::execute_loop::multi_read_unit::read_unit::read_queue::Parameters * param);
 
-class Time 
-{
-private : timeval time_begin;
-// private : timeval time_end;
-  
-public  : Time ()
-  {
-    gettimeofday(&time_begin     ,NULL);
-  };
-
-public  : ~Time ()
-  {
-    cout << *this;
-  };
-
-public  : friend ostream& operator<< (ostream& output_stream,
-				      const Time & x)
-  {
-    timeval time_end;
-    
-    gettimeofday(&time_end       ,NULL);
-    
-    uint32_t nb_cycles = static_cast<uint32_t>(sc_simulation_time());
-
-    double average = static_cast<double>(nb_cycles) / static_cast<double>(time_end.tv_sec-x.time_begin.tv_sec);
-    
-    output_stream << nb_cycles << "\t(" << average << " cycles / seconds )" << endl;
-
-    return output_stream;
-  }
-};
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/SelfTest/src/main.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/SelfTest/src/main.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/SelfTest/src/main.cpp	(revision 88)
@@ -77,4 +77,5 @@
 	 ,size_store_queue
 	 ,size_load_queue 
+         ,true //is_toplevel
 	  );
       
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/SelfTest/src/test.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/SelfTest/src/test.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/SelfTest/src/test.cpp	(revision 88)
@@ -23,4 +23,14 @@
 #endif
 
+  Tusage_t _usage = USE_ALL;
+
+//   _usage = usage_unset(_usage,USE_SYSTEMC              );
+//   _usage = usage_unset(_usage,USE_VHDL                 );
+//   _usage = usage_unset(_usage,USE_VHDL_TESTBENCH       );
+//   _usage = usage_unset(_usage,USE_VHDL_TESTBENCH_ASSERT);
+//   _usage = usage_unset(_usage,USE_POSITION             );
+//   _usage = usage_unset(_usage,USE_STATISTICS           );
+//   _usage = usage_unset(_usage,USE_INFORMATION          );
+
   Read_queue * _Read_queue = new Read_queue (name.c_str(),
 #ifdef STATISTICS
@@ -28,5 +38,5 @@
 #endif
 					     _param,
-					     USE_ALL);
+					     _usage);
   
 #ifdef SYSTEMC
@@ -200,5 +210,5 @@
   if(_param->_have_port_ooo_engine_id)
     (*(_Read_queue-> in_READ_QUEUE_IN_OOO_ENGINE_ID  )) (*(READ_QUEUE_IN_OOO_ENGINE_ID  ));
-  if(_param->_have_port_rob_id       )
+  if(_param->_have_port_rob_ptr       )
     (*(_Read_queue-> in_READ_QUEUE_IN_ROB_ID         )) (*(READ_QUEUE_IN_ROB_ID         ));
   (*(_Read_queue-> in_READ_QUEUE_IN_OPERATION      )) (*(READ_QUEUE_IN_OPERATION      ));
@@ -228,5 +238,5 @@
   if(_param->_have_port_ooo_engine_id)
     (*(_Read_queue->out_READ_QUEUE_OUT_OOO_ENGINE_ID )) (*(READ_QUEUE_OUT_OOO_ENGINE_ID )); 
-  if(_param->_have_port_rob_id       )
+  if(_param->_have_port_rob_ptr       )
     (*(_Read_queue->out_READ_QUEUE_OUT_ROB_ID        )) (*(READ_QUEUE_OUT_ROB_ID        )); 
   (*(_Read_queue->out_READ_QUEUE_OUT_OPERATION     )) (*(READ_QUEUE_OUT_OPERATION     )); 
@@ -388,5 +398,5 @@
 	      if(_param->_have_port_front_end_id )
 		READ_QUEUE_IN_FRONT_END_ID   ->write((3*_ooo_engine_id [request_in])%_param->_nb_front_end);
-	      if(_param->_have_port_rob_id       )
+	      if(_param->_have_port_rob_ptr       )
 		READ_QUEUE_IN_ROB_ID      ->write(request_in);
 	      READ_QUEUE_IN_OPERATION   ->write(0);
@@ -504,5 +514,5 @@
 	    {
 	      Tpacket_t  rob_id;
-	      if(_param->_have_port_rob_id       )
+	      if(_param->_have_port_rob_ptr       )
 		rob_id = READ_QUEUE_OUT_ROB_ID->read();
 	      else
@@ -551,4 +561,5 @@
   TEST_OK ("End of Simulation");
   delete _time;
+
   cout << "<" << name << "> ............ Stop Simulation" << endl;
 
@@ -564,5 +575,5 @@
    if(_param->_have_port_ooo_engine_id )
      delete    READ_QUEUE_IN_OOO_ENGINE_ID;
-   if(_param->_have_port_rob_id       )
+   if(_param->_have_port_rob_ptr       )
      delete    READ_QUEUE_IN_ROB_ID    ;
    delete    READ_QUEUE_IN_OPERATION    ;
@@ -592,5 +603,5 @@
    if(_param->_have_port_ooo_engine_id )
      delete    READ_QUEUE_OUT_OOO_ENGINE_ID;
-   if(_param->_have_port_rob_id       )
+   if(_param->_have_port_rob_ptr       )
      delete    READ_QUEUE_OUT_ROB_ID      ;
    delete    READ_QUEUE_OUT_OPERATION   ;
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/include/Parameters.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/include/Parameters.h	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/include/Parameters.h	(revision 88)
@@ -28,34 +28,34 @@
   {
     //-----[ fields ]------------------------------------------------------------
-  public : const uint32_t    _size_queue           ;
-  public : const uint32_t    _nb_context           ;
-  public : const uint32_t    _nb_front_end         ;
-  public : const uint32_t    _nb_ooo_engine        ;
-  public : const uint32_t    _nb_packet            ;
-  public : const uint32_t    _size_general_data    ;
-  public : const uint32_t    _size_special_data    ;
-  public : const uint32_t    _nb_general_register  ;
-  public : const uint32_t    _nb_special_register  ;
-  public : const uint32_t    _nb_gpr_write         ;
-  public : const uint32_t    _nb_spr_write         ;
-  public : const uint32_t    _size_store_queue     ;
-  public : const uint32_t    _size_load_queue      ;
+  public : uint32_t    _size_queue           ;
+  public : uint32_t    _nb_context           ;
+  public : uint32_t    _nb_front_end         ;
+  public : uint32_t    _nb_ooo_engine        ;
+  public : uint32_t    _nb_packet            ;
+//public : uint32_t    _size_general_data    ;
+//public : uint32_t    _size_special_data    ;
+  public : uint32_t    _nb_general_register  ;
+  public : uint32_t    _nb_special_register  ;
+  public : uint32_t    _nb_gpr_write         ;
+  public : uint32_t    _nb_spr_write         ;
+//public : uint32_t    _size_store_queue     ;
+//public : uint32_t    _size_load_queue      ;
 
-  public : const uint32_t    _nb_gpr_read          ;
-  public : const uint32_t    _nb_spr_read          ;    
-  public : const uint32_t    _size_context_id      ;
-  public : const uint32_t    _size_front_end_id    ;
-  public : const uint32_t    _size_ooo_engine_id   ;
-  public : const uint32_t    _size_rob_id          ;
-  public : const uint32_t    _size_general_register;
-  public : const uint32_t    _size_special_register;
+  public : uint32_t    _nb_gpr_read          ;
+  public : uint32_t    _nb_spr_read          ;    
+//public : uint32_t    _size_context_id      ;
+//public : uint32_t    _size_front_end_id    ;
+//public : uint32_t    _size_ooo_engine_id   ;
+//public : uint32_t    _size_rob_id          ;
+//public : uint32_t    _size_general_register;
+//public : uint32_t    _size_special_register;
 
-  public : const bool        _have_port_context_id   ;
-  public : const bool        _have_port_front_end_id ;
-  public : const bool        _have_port_ooo_engine_id;
-  public : const bool        _have_port_rob_id       ;
-  public : const bool        _have_port_load_queue_ptr;
+//public : bool        _have_port_context_id   ;
+//public : bool        _have_port_front_end_id ;
+//public : bool        _have_port_ooo_engine_id;
+//public : bool        _have_port_rob_id       ;
+//public : bool        _have_port_load_queue_ptr;
 
-  public : const uint32_t    _size_internal_queue;
+  public : uint32_t    _size_internal_queue;
 
     //-----[ methods ]-----------------------------------------------------------
@@ -72,8 +72,11 @@
 			uint32_t nb_spr_write       ,
 			uint32_t size_store_queue   ,
-			uint32_t size_load_queue    );
+			uint32_t size_load_queue    ,
+                        bool     is_toplevel=false  );
 
-  public : Parameters  (Parameters & param) ;
-  public : ~Parameters () ;
+//public : Parameters  (Parameters & param) ;
+  public : ~Parameters (void) ;
+
+  public : void                 copy      (void);
 
   public : Parameters_test      msg_error (void);
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/include/Read_queue.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/include/Read_queue.h	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/include/Read_queue.h	(revision 88)
@@ -14,5 +14,5 @@
 
 #include <iostream>
-#include <queue>
+#include <list>
 #include "Common/include/ToString.h"
 #include "Common/include/Debug.h"
@@ -154,5 +154,5 @@
     // ~~~~~[ Register ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
   protected : Tread_queue_head_entry_t       * _queue_head;
-  protected : std::queue<Tread_queue_entry_t *>   * _queue;
+  protected : std::list<Tread_queue_entry_t *>   * _queue;
 
     // ~~~~~[ Internal ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/src/Parameters.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/src/Parameters.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/src/Parameters.cpp	(revision 88)
@@ -30,104 +30,118 @@
 			  uint32_t nb_spr_write       ,
 			  uint32_t size_store_queue   ,
-			  uint32_t size_load_queue    ):
-    _size_queue            (size_queue           ),
-    _nb_context            (nb_context           ),
-    _nb_front_end          (nb_front_end         ),
-    _nb_ooo_engine         (nb_ooo_engine        ),
-    _nb_packet             (nb_packet            ),
-    _size_general_data     (size_general_data    ),
-    _size_special_data     (size_special_data    ),
-    _nb_general_register   (nb_general_register  ),
-    _nb_special_register   (nb_special_register  ),
-    _nb_gpr_write          (nb_gpr_write         ),
-    _nb_spr_write          (nb_spr_write         ),
-    _size_store_queue      (size_store_queue     ),
-    _size_load_queue       (size_load_queue      ),
-
-    _nb_gpr_read           (2                    ),
-    _nb_spr_read           (1                    ),
-    _size_context_id       (static_cast<uint32_t>(log2(_nb_context         ))),
-    _size_front_end_id     (static_cast<uint32_t>(log2(_nb_front_end       ))),
-    _size_ooo_engine_id    (static_cast<uint32_t>(log2(_nb_ooo_engine      ))),
-    _size_rob_id           (static_cast<uint32_t>(log2(_nb_packet          ))),
-    _size_general_register (static_cast<uint32_t>(log2(_nb_general_register))),
-    _size_special_register (static_cast<uint32_t>(log2(_nb_special_register))),
-
-    _have_port_context_id    (_size_context_id    > 0),
-    _have_port_front_end_id  (_size_front_end_id  > 0),
-    _have_port_ooo_engine_id (_size_ooo_engine_id > 0),
-    _have_port_rob_id        (_size_rob_id        > 0),
-    _have_port_load_queue_ptr(_size_load_queue    > 1),
-
-    _size_internal_queue     (  _size_context_id       //_context_id   
-			      + _size_front_end_id     //_front_end_id 
-			      + _size_ooo_engine_id    //_ooo_engine_id
-			      + _size_rob_id           //_rob_id       
-			      + _size_operation        //_operation    
-			      + _size_type             //_type         
-			      + log2(_size_store_queue)//_store_queue_ptr_write
-			      + log2(_size_load_queue )//_load_queue_ptr_write 
-			      + 1                      //_has_immediat 
-			      + _size_general_data     //_immediat     
-			      + 1                      //_read_ra      
-			      + _size_general_register //_num_reg_ra   
-			      + 1                      //_read_rb      
-			      + _size_general_register //_num_reg_rb   
-			      + 1                      //_read_rc      
-			      + _size_special_register //_num_reg_rc   
-			      + 1                      //_write_rd     
-			      + _size_general_register //_num_reg_rd   
-			      + 1                      //_write_re     
-			      + _size_special_register //_num_reg_re   
-				)
-				
-
+			  uint32_t size_load_queue    ,
+                          bool     is_toplevel)
   {
     log_printf(FUNC,Read_queue,"Parameters","Begin");
+
+    _size_queue              = size_queue           ;
+    _nb_context              = nb_context           ;
+    _nb_front_end            = nb_front_end         ;
+    _nb_ooo_engine           = nb_ooo_engine        ;
+    _nb_packet               = nb_packet            ;
+    _nb_general_register     = nb_general_register  ;
+    _nb_special_register     = nb_special_register  ;
+    _nb_gpr_write            = nb_gpr_write         ;
+    _nb_spr_write            = nb_spr_write         ;
+                             
+    _nb_gpr_read             = 2                    ;
+    _nb_spr_read             = 1                    ;
+
+    _size_internal_queue     = (  log2(nb_context         ) //_context_id   
+                                + log2(nb_front_end       ) //_front_end_id 
+                                + log2(nb_ooo_engine      ) //_ooo_engine_id
+                                + log2(nb_packet          ) //_rob_id       
+                                + _size_operation           //_operation    
+                                + _size_type                //_type         
+                                + log2(size_store_queue   ) //_store_queue_ptr_write
+                                + log2(size_load_queue    ) //_load_queue_ptr_write 
+                                + 1                         //_has_immediat 
+                                +  size_general_data        //_immediat     
+                                + 1                         //_read_ra      
+                                + log2(nb_general_register) //_num_reg_ra   
+                                + 1                         //_read_rb      
+                                + log2(nb_general_register) //_num_reg_rb   
+                                + 1                         //_read_rc      
+                                + log2(nb_special_register) //_num_reg_rc   
+                                + 1                         //_write_rd     
+                                + log2(nb_general_register) //_num_reg_rd   
+                                + 1                         //_write_re     
+                                + log2(nb_special_register) //_num_reg_re   
+				);
+
     test();
+
+    if (is_toplevel)
+      {
+        _size_general_data       = size_general_data    ;
+        _size_special_data       = size_special_data    ;
+        _size_store_queue_ptr    = log2(size_store_queue);
+        _size_load_queue_ptr     = log2(size_load_queue );
+        _size_context_id         = log2(_nb_context         );
+        _size_front_end_id       = log2(_nb_front_end       );
+        _size_ooo_engine_id      = log2(_nb_ooo_engine      );
+        _size_rob_ptr            = log2(_nb_packet          );
+        _size_general_register   = log2(_nb_general_register);
+        _size_special_register   = log2(_nb_special_register);
+        
+        _have_port_context_id    = _size_context_id    > 0;
+        _have_port_front_end_id  = _size_front_end_id  > 0;
+        _have_port_ooo_engine_id = _size_ooo_engine_id > 0;
+        _have_port_rob_ptr       = _size_rob_ptr       > 0;
+        _have_port_load_queue_ptr= _size_load_queue_ptr> 0;
+        
+        copy();
+      }
+
     log_printf(FUNC,Read_queue,"Parameters","End");
   };
   
-  Parameters::Parameters (Parameters & param):
-    _size_queue            (param._size_queue            ),
-    _nb_context            (param._nb_context            ),
-    _nb_front_end          (param._nb_front_end          ),
-    _nb_ooo_engine         (param._nb_ooo_engine         ),
-    _nb_packet             (param._nb_packet             ),
-    _size_general_data     (param._size_general_data     ),
-    _size_special_data     (param._size_special_data     ),
-    _nb_general_register   (param._nb_general_register   ),
-    _nb_special_register   (param._nb_special_register   ),
-    _nb_gpr_write          (param._nb_gpr_write          ),
-    _nb_spr_write          (param._nb_spr_write          ),
-    _size_store_queue      (param._size_store_queue      ),
-    _size_load_queue       (param._size_load_queue       ),
+//   Parameters::Parameters (Parameters & param):
+//     _size_queue            (param._size_queue            ),
+//     _nb_context            (param._nb_context            ),
+//     _nb_front_end          (param._nb_front_end          ),
+//     _nb_ooo_engine         (param._nb_ooo_engine         ),
+//     _nb_packet             (param._nb_packet             ),
+//     _size_general_data     (param._size_general_data     ),
+//     _size_special_data     (param._size_special_data     ),
+//     _nb_general_register   (param._nb_general_register   ),
+//     _nb_special_register   (param._nb_special_register   ),
+//     _nb_gpr_write          (param._nb_gpr_write          ),
+//     _nb_spr_write          (param._nb_spr_write          ),
+//     _size_store_queue      (param._size_store_queue      ),
+//     _size_load_queue       (param._size_load_queue       ),
 
-    _nb_gpr_read           (param._nb_gpr_read           ),
-    _nb_spr_read           (param._nb_spr_read           ),
-    _size_context_id       (param._size_context_id       ),
-    _size_front_end_id     (param._size_front_end_id     ),
-    _size_ooo_engine_id    (param._size_ooo_engine_id    ),
-    _size_rob_id           (param._size_rob_id           ),
-    _size_general_register (param._size_general_register ),
-    _size_special_register (param._size_special_register ),
+//     _nb_gpr_read           (param._nb_gpr_read           ),
+//     _nb_spr_read           (param._nb_spr_read           ),
+//     _size_context_id       (param._size_context_id       ),
+//     _size_front_end_id     (param._size_front_end_id     ),
+//     _size_ooo_engine_id    (param._size_ooo_engine_id    ),
+//     _size_rob_id           (param._size_rob_id           ),
+//     _size_general_register (param._size_general_register ),
+//     _size_special_register (param._size_special_register ),
 
-    _have_port_context_id    (param._have_port_context_id   ),
-    _have_port_front_end_id  (param._have_port_front_end_id ),
-    _have_port_ooo_engine_id (param._have_port_ooo_engine_id),
-    _have_port_rob_id        (param._have_port_rob_id       ),
-    _have_port_load_queue_ptr(param._have_port_load_queue_ptr),
+//     _have_port_context_id    (param._have_port_context_id   ),
+//     _have_port_front_end_id  (param._have_port_front_end_id ),
+//     _have_port_ooo_engine_id (param._have_port_ooo_engine_id),
+//     _have_port_rob_id        (param._have_port_rob_id       ),
+//     _have_port_load_queue_ptr(param._have_port_load_queue_ptr),
 
-    _size_internal_queue     (param._size_internal_queue    )
-  {
-    log_printf(FUNC,Read_queue,"Parameters (copy)","Begin");
-    test();
-    log_printf(FUNC,Read_queue,"Parameters (copy)","End");
-  };
+//     _size_internal_queue     (param._size_internal_queue    )
+//   {
+//     log_printf(FUNC,Read_queue,"Parameters (copy)","Begin");
+//     test();
+//     log_printf(FUNC,Read_queue,"Parameters (copy)","End");
+//   };
 
-  Parameters::~Parameters () 
+  Parameters::~Parameters (void) 
   {
     log_printf(FUNC,Read_queue,"~Parameters","Begin");
     log_printf(FUNC,Read_queue,"~Parameters","End");
+  };
+
+  void Parameters::copy (void) 
+  {
+    log_printf(FUNC,Read_queue,"copy","Begin");
+    log_printf(FUNC,Read_queue,"copy","End");
   };
 
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/src/Parameters_print.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/src/Parameters_print.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/src/Parameters_print.cpp	(revision 88)
@@ -31,12 +31,12 @@
     xml.singleton_begin("nb_ooo_engine      "); xml.attribut("value",toString(_nb_ooo_engine      )); xml.singleton_end();
     xml.singleton_begin("nb_packet          "); xml.attribut("value",toString(_nb_packet          )); xml.singleton_end();
-    xml.singleton_begin("size_general_data  "); xml.attribut("value",toString(_size_general_data  )); xml.singleton_end();
-    xml.singleton_begin("size_special_data  "); xml.attribut("value",toString(_size_special_data  )); xml.singleton_end();
+//  xml.singleton_begin("size_general_data  "); xml.attribut("value",toString(_size_general_data  )); xml.singleton_end();
+//  xml.singleton_begin("size_special_data  "); xml.attribut("value",toString(_size_special_data  )); xml.singleton_end();
     xml.singleton_begin("nb_general_register"); xml.attribut("value",toString(_nb_general_register)); xml.singleton_end();
     xml.singleton_begin("nb_special_register"); xml.attribut("value",toString(_nb_special_register)); xml.singleton_end();
     xml.singleton_begin("nb_gpr_write       "); xml.attribut("value",toString(_nb_gpr_write       )); xml.singleton_end();
     xml.singleton_begin("nb_spr_write       "); xml.attribut("value",toString(_nb_spr_write       )); xml.singleton_end();
-    xml.singleton_begin("size_store_queue   "); xml.attribut("value",toString(_size_store_queue   )); xml.singleton_end();
-    xml.singleton_begin("size_load_queue    "); xml.attribut("value",toString(_size_load_queue    )); xml.singleton_end();
+//  xml.singleton_begin("size_store_queue   "); xml.attribut("value",toString(_size_store_queue   )); xml.singleton_end();
+//  xml.singleton_begin("size_load_queue    "); xml.attribut("value",toString(_size_load_queue    )); xml.singleton_end();
 
     xml.balise_close();
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/src/Read_queue.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/src/Read_queue.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/src/Read_queue.cpp	(revision 88)
@@ -36,4 +36,10 @@
     log_printf(FUNC,Read_queue,"Read_queue","Begin");
 
+#if DEBUG_Read_queue == true
+    log_printf(INFO,Read_queue,FUNCTION,_("<%s> Parameters"),_name.c_str());
+
+    std::cout << *param << std::endl;
+#endif    
+
 #ifdef SYSTEMC
     log_printf(INFO,Read_queue,"Read_queue","Allocation");
@@ -43,17 +49,25 @@
 
 #ifdef STATISTICS
-    log_printf(INFO,Read_queue,FUNCTION,"Allocation of statistics");
-    
-    statistics_declaration(param_statistics);
+    if (usage_is_set(_usage,USE_STATISTICS))
+      {	
+        log_printf(INFO,Read_queue,FUNCTION,"Allocation of statistics");
+        
+        statistics_declaration(param_statistics);
+      }
 #endif
 
 #ifdef VHDL
-    // generate the vhdl
-    log_printf(INFO,Read_queue,"Read_queue","Generate the vhdl");
-
-    vhdl();
-#endif
-
-#ifdef SYSTEMC
+    if (usage_is_set(_usage,USE_VHDL))
+      {	
+        // generate the vhdl
+        log_printf(INFO,Read_queue,"Read_queue","Generate the vhdl");
+        
+        vhdl();
+      }
+#endif
+
+#ifdef SYSTEMC
+    if (usage_is_set(_usage,USE_SYSTEMC))
+      {	
     log_printf(INFO,Read_queue,"Read_queue","Method - transition");
 
@@ -206,5 +220,5 @@
       }
 #endif    
-
+      }
 #endif
     log_printf(FUNC,Read_queue,"Read_queue","End");
@@ -216,7 +230,10 @@
 
 #ifdef STATISTICS
-    log_printf(INFO,Read_queue,"~Read_queue","Generate Statistics file");
-
-    delete _stat;
+    if (usage_is_set(_usage,USE_STATISTICS))
+      {	
+        log_printf(INFO,Read_queue,"~Read_queue","Generate Statistics file");
+        
+        delete _stat;
+      }
 #endif
 
